# SolverCore

[![Stable Documentation](https://img.shields.io/badge/docs-stable-blue.svg)](https://JuliaSmoothOptimizers.github.io/SolverCore.jl/stable)
[![In development documentation](https://img.shields.io/badge/docs-dev-blue.svg)](https://JuliaSmoothOptimizers.github.io/SolverCore.jl/dev)
[![Build Status](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/workflows/Test/badge.svg)](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/actions)
[![Test workflow status](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/actions/workflows/Test.yml/badge.svg?branch=main)](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/actions/workflows/Test.yml?query=branch%3Amain)
[![Lint workflow Status](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/actions/workflows/Lint.yml/badge.svg?branch=main)](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/actions/workflows/Lint.yml?query=branch%3Amain)
[![Docs workflow Status](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/actions/workflows/Docs.yml/badge.svg?branch=main)](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/actions/workflows/Docs.yml?query=branch%3Amain)
[![Coverage](https://codecov.io/gh/JuliaSmoothOptimizers/SolverCore.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaSmoothOptimizers/SolverCore.jl)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.4758376.svg)](https://doi.org/10.5281/zenodo.4758376)
[![Contributor Covenant](https://img.shields.io/badge/Contributor%20Covenant-2.1-4baaaa.svg)](CODE_OF_CONDUCT.md)
[![All Contributors](https://img.shields.io/github/all-contributors/JuliaSmoothOptimizers/SolverCore.jl?labelColor=5e1ec7&color=c0ffee&style=flat-square)](#contributors)
[![BestieTemplate](https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/JuliaBesties/BestieTemplate.jl/main/docs/src/assets/badge.json)](https://github.com/JuliaBesties/BestieTemplate.jl)

Core package to build novel algorithms in Julia.

## How to Cite

If you use SolverCore.jl in your work, please cite using the reference given in [CITATION.cff](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/blob/main/CITATION.cff).

## Contributing

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers) organization, so questions about any of our packages are welcome.

If you want to make contributions of any kind, please first that a look into our [contributing guide directly on GitHub](docs/src/90-contributing.md) or the [contributing page on the website](https://JuliaSmoothOptimizers.github.io/SolverCore.jl/dev/90-contributing/)

---

### Contributors

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->

export AbstractSolver, AbstractOptimizationSolver, solve!, reset!

"Abstract type from which JSO solvers derive."
abstract type AbstractSolver end

abstract type AbstractOptimizationSolver <: AbstractSolver end

"""
    reset!(solver::::AbstractSolver, model)
    reset!(solver::::AbstractSolver)

Use in the context of restarting or reusing the `solver` structure.
Reset the internal fields of `solver` for the `model` before calling `solve!` on the same structure.
`model` must have the same number of variables, bounds and constraints as that used to instantiate `solver`.
"""
function reset!(solver::AbstractSolver) end
function reset!(solver::AbstractSolver, model) end

"""
    solve!(solver, model; kwargs...)
    solve!(solver, model, stats; kwargs...)

Apply `solver` to `model`.

# Arguments

- `solver::::AbstractSolver`: solver structure to hold all storage necessary for a solve
- `model`: the model solved
- `stats::GenericExecutionStats`: stats structure to hold solution information.

The first invocation allocates and returns a new `GenericExecutionStats`.
The second one fills out a preallocated stats structure and allows for efficient re-solves.

The `kwargs` are passed to the solver.

# Return Value

- `stats::GenericExecutionStats`: stats structure holding solution information.
"""
function solve!(solver::AbstractSolver, model; kwargs...) end
function solve!(solver::AbstractSolver, model, stats; kwargs...) end

export AbstractExecutionStats,
  GenericExecutionStats,
  set_status!,
  get_status,
  set_solution!,
  set_objective!,
  set_residuals!,
  set_primal_residual!,
  set_dual_residual!,
  set_multipliers!,
  set_constraint_multipliers!,
  set_bounds_multipliers!,
  set_iter!,
  set_step_status!,
  set_time!,
  broadcast_solver_specific!,
  set_solver_specific!,
  statsgetfield,
  statshead,
  statsline,
  getStatus,
  show_statuses,
  show_step_statuses

const STATUSES = Dict(
  :exception => "unhandled exception",
  :first_order => "first-order stationary",
  :acceptable => "solved to within acceptable tolerances",
  :infeasible => "problem may be infeasible",
  :max_eval => "maximum number of function evaluations",
  :max_iter => "maximum iteration",
  :max_time => "maximum elapsed time",
  :neg_pred => "negative predicted reduction",
  :not_desc => "not a descent direction",
  :small_residual => "small residual",
  :small_step => "step too small",
  :stalled => "stalled",
  :unbounded => "objective function may be unbounded from below",
  :prox_unbounded => "the regularizer is not prox bounded",
  :unknown => "unknown",
  :user => "user-requested stop",
)

function check_status(status::Symbol)
  if !(status in keys(STATUSES))
    @error "status $status is not a valid status. Use one of the following: " join(
      keys(STATUSES),
      ", ",
    )
    throw(KeyError(status))
  end
end

"""
    show_statuses()

Show the list of available statuses to use with `GenericExecutionStats`.
"""
function show_statuses()
  println("STATUSES:")
  for k in keys(STATUSES) |> collect |> sort
    v = STATUSES[k]
    @printf("  :%-14s => %s\n", k, v)
  end
end

const STEP_STATUSES =
  Dict(:unknown => "unknown", :accepted => "step accepted", :rejected => "step rejected")

function check_step_status(step_status::Symbol)
  if !(step_status in keys(STEP_STATUSES))
    @error "step_status $step_status is not a valid step status. Use one of the following: " join(
      keys(STEP_STATUSES),
      ", ",
    )
    throw(KeyError(step_status))
  end
end

"""
    show_step_statuses()

Show the list of available step statuses to use with `GenericExecutionStats`.
"""
function show_step_statuses()
  println("STEP_STATUSES:")
  for k in keys(STEP_STATUSES) |> collect |> sort
    v = STEP_STATUSES[k]
    @printf("  :%-10s => %s\n", k, v)
  end
end

abstract type AbstractExecutionStats end

"""
    GenericExecutionStats(nlp; ...)
    GenericExecutionStats{T, S, V, Tsp}(;...)

A GenericExecutionStats is a struct for storing the output information of solvers.
It contains the following fields:
- `status`: Indicates the output of the solver. Use `show_statuses()` for the full list;
- `solution`: The final approximation returned by the solver (default: an uninitialized vector like `nlp.meta.x0`);
- `objective`: The objective value at `solution` (default: `Inf`);
- `dual_feas`: The dual feasibility norm at `solution` (default: `Inf`);
- `primal_feas`: The primal feasibility norm at `solution` (default: `0.0` if unconstrained, `Inf` otherwise);
- `multipliers`: The Lagrange multipliers wrt to the constraints (default: an uninitialized vector like `nlp.meta.y0`);
- `multipliers_L`: The Lagrange multipliers wrt to the lower bounds on the variables (default: an uninitialized vector like `nlp.meta.x0` if there are bounds, or a zero-length vector if not);
- `multipliers_U`: The Lagrange multipliers wrt to the upper bounds on the variables (default: an uninitialized vector like `nlp.meta.x0` if there are bounds, or a zero-length vector if not);
- `iter`: The number of iterations computed by the solver (default: `-1`);
- `step_status`: The status of the most recently computed step. Use show_step_statuses() for the full list (default: `:unknown`);
- `elapsed_time`: The elapsed time computed by the solver (default: `Inf`);
- `solver_specific::Dict{Symbol,Any}`: A solver specific dictionary.

The constructor preallocates storage for the fields above.
Special storage may be used for `multipliers_L` and `multipliers_U` by passing them to the constructor.
For instance, if a problem has few bound constraints, those multipliers could be held in sparse vectors.

The following fields indicate whether the information above has been updated and is reliable:

- `solution_reliable`
- `objective_reliable`
- `residuals_reliable` (for `dual_feas` and `primal_feas`)
- `multipliers_reliable` (for `multipliers`)
- `bounds_multipliers_reliable` (for `multipliers_L` and `multipliers_U`)
- `iter_reliable`
- `step_status_reliable`
- `time_reliable`
- `solver_specific_reliable`.

Setting fields using one of the methods `set_solution!()`, `set_objective!()`, etc., also marks
the field value as reliable.

The `reset!()` method marks all fields as unreliable.

`nlp` is highly recommended to set default optional fields.
If it is not provided, the function `reset!(stats, nlp)` should be called before `solve!`.

All other variables can be input as keyword arguments.

Notice that `GenericExecutionStats` does not compute anything, it simply stores.
"""
mutable struct GenericExecutionStats{T, S, V, Tsp} <: AbstractExecutionStats
  status_reliable::Bool
  status::Symbol
  solution_reliable::Bool
  solution::S # x
  objective_reliable::Bool
  objective::T # f(x)
  dual_residual_reliable::Bool
  dual_feas::T # ‖∇f(x)‖₂ for unc, ‖P[x - ∇f(x)] - x‖₂ for bnd, etc.
  primal_residual_reliable::Bool
  primal_feas::T # ‖c(x)‖ for equalities
  multipliers_reliable::Bool
  multipliers::S # y
  bounds_multipliers_reliable::Bool
  multipliers_L::V # zL
  multipliers_U::V # zU
  iter_reliable::Bool
  iter::Int
  step_status_reliable::Bool
  step_status::Symbol
  time_reliable::Bool
  elapsed_time::Float64
  solver_specific_reliable::Bool
  solver_specific::Dict{Symbol, Tsp}
end

function GenericExecutionStats{T, S, V, Tsp}(;
  status::Symbol = :unknown,
  solution::S = S(),
  objective::T = T(Inf),
  dual_feas::T = T(Inf),
  primal_feas::T = T(Inf),
  multipliers::S = S(),
  multipliers_L::V = V(),
  multipliers_U::V = V(),
  iter::Int = -1,
  step_status::Symbol = :unknown,
  elapsed_time::Real = Inf,
  solver_specific::Dict{Symbol, Tsp} = Dict{Symbol, Any}(),
) where {T, S, V, Tsp}
  return GenericExecutionStats{T, S, V, Tsp}(
    false,
    status,
    false,
    solution,
    false,
    objective,
    false,
    dual_feas,
    false,
    primal_feas,
    false,
    multipliers,
    false,
    multipliers_L,
    multipliers_U,
    false,
    iter,
    false,
    step_status,
    false,
    elapsed_time,
    false,
    solver_specific,
  )
end

"""
    reset!(stats::GenericExecutionStats)
    reset!(stats::GenericExecutionStats, problem)

Reset the internal flags of `stats` to `false` to Indicate
that the contents should not be trusted.
"""
function reset!(stats::GenericExecutionStats{T, S, V, Tsp}) where {T, S, V, Tsp}
  stats.status_reliable = false
  stats.solution_reliable = false
  stats.objective_reliable = false
  stats.primal_residual_reliable = false
  stats.dual_residual_reliable = false
  stats.multipliers_reliable = false
  stats.bounds_multipliers_reliable = false
  stats.iter_reliable = false
  stats.step_status_reliable = false
  stats.time_reliable = false
  stats.solver_specific_reliable = false
  stats
end

function reset!(stats::GenericExecutionStats, problem::Any)
  return reset!(stats)
end

"""
    set_status!(stats::GenericExecutionStats, status::Symbol)

Register `status` as final status in `stats` and mark it as reliable.
"""
function set_status!(stats::GenericExecutionStats, status::Symbol)
  check_status(status)
  stats.status = status
  stats.status_reliable = true
  stats
end

"""
    set_solution!(stats::GenericExecutionStats, x::AbstractVector)

Register `x` as optimal solution in `stats` and mark it as reliable.
"""
function set_solution!(stats::GenericExecutionStats, x::AbstractVector)
  stats.solution .= x
  stats.solution_reliable = true
  stats
end

"""
    set_objective!(stats::GenericExecutionStats{T, S, V}, val::T)

Register `val` as optimal objective value in `stats` and mark it as reliable.
"""
function set_objective!(stats::GenericExecutionStats{T, S, V}, val::T) where {T, S, V}
  stats.objective = val
  stats.objective_reliable = true
  stats
end

"""
    set_residuals!(stats::GenericExecutionStats{T, S, V}, primal::T, dual::T)

Register `primal` and `dual` as optimal primal and dual feasibility residuals,
respectively, in `stats` and mark them as reliable.
"""
function set_residuals!(stats::GenericExecutionStats{T, S, V}, primal::T, dual::T) where {T, S, V}
  set_primal_residual!(stats, primal)
  set_dual_residual!(stats, dual)
  stats
end

"""
    set_primal_residual!(stats::GenericExecutionStats{T, S, V}, primal::T)

Register `primal` as optimal primal residuals in `stats` and mark it as reliable.
"""
function set_primal_residual!(stats::GenericExecutionStats{T, S, V}, primal::T) where {T, S, V}
  stats.primal_feas = primal
  stats.primal_residual_reliable = true
  stats
end

"""
    set_dual_residual!(stats::GenericExecutionStats{T, S, V}, dual::T)

Register `dual` as optimal dual feasibility residuals in `stats` and mark it as reliable.
"""
function set_dual_residual!(stats::GenericExecutionStats{T, S, V}, dual::T) where {T, S, V}
  stats.dual_feas = dual
  stats.dual_residual_reliable = true
  stats
end

"""
    set_multipliers!(stats::GenericExecutionStats{T, S, V}, y::S, zL::V, zU::V)

Register `y`, `zL` and `zU` as optimal multipliers associated to general constraints,
lower-bounded and upper-bounded constraints, respectively, in `stats` and mark them as reliable.
"""
function set_multipliers!(stats::GenericExecutionStats{T, S, V}, y::S, zL::V, zU::V) where {T, S, V}
  set_bounds_multipliers!(stats, zL, zU)
  set_constraint_multipliers!(stats, y)
  stats
end

"""
    set_bounds_multipliers!(stats::GenericExecutionStats{T, S, V}, zL::V, zU::V)

Register `zL` and `zU` as optimal multipliers associated to lower-bounded and upper-bounded constraints, respectively, in `stats` and mark them as reliable.
"""
function set_bounds_multipliers!(
  stats::GenericExecutionStats{T, S, V},
  zL::V,
  zU::V,
) where {T, S, V}
  stats.multipliers_L .= zL
  stats.multipliers_U .= zU
  stats.bounds_multipliers_reliable = true
  stats
end

"""
    set_constraint_multipliers!(stats::GenericExecutionStats{T, S, V}, y::S, zL::V, zU::V)

Register `y` as optimal multipliers associated to general constraints in `stats` and mark them as reliable.
"""
function set_constraint_multipliers!(stats::GenericExecutionStats{T, S, V}, y::S) where {T, S, V}
  stats.multipliers .= y
  stats.multipliers_reliable = true
  stats
end

"""
    set_iter!(stats::GenericExecutionStats, iter::Int)

Register `iter` as optimal iteration number in `stats` and mark it as reliable.
"""
function set_iter!(stats::GenericExecutionStats, iter::Int)
  stats.iter = iter
  stats.iter_reliable = true
  stats
end

"""
    set_step_status!(stats::GenericExecutionStats, step_status::Symbol)

Register `step_status` as most recent step status in `stats` and mark it as reliable.
"""
function set_step_status!(stats::GenericExecutionStats, step_status::Symbol)
  check_step_status(step_status)
  stats.step_status = step_status
  stats.step_status_reliable = true
  stats
end

"""
    set_time!(stats::GenericExecutionStats, time::Float64)

Register `time` as optimal solution time in `stats` and mark it as reliable.
"""
function set_time!(stats::GenericExecutionStats, time::Float64)
  stats.elapsed_time = time
  stats.time_reliable = true
  stats
end

"""
    broadcast_solver_specific!(stats::GenericExecutionStats, field::Symbol, value)

Broadcast `value` as a solver-specific value identified by `field` in `stats`
and mark it as reliable.
"""
function broadcast_solver_specific!(stats::GenericExecutionStats, field::Symbol, value)
  if field ∈ keys(stats.solver_specific)
    stats.solver_specific[field] .= value
  end
  stats.solver_specific_reliable = true
  stats
end

"""
    set_solver_specific!(stats::GenericExecutionStats, field::Symbol, value)

Register `value` as a solver-specific value identified by `field` in `stats`
and mark it as reliable.
"""
function set_solver_specific!(stats::GenericExecutionStats, field::Symbol, value)
  stats.solver_specific[field] = value
  stats.solver_specific_reliable = true
  stats
end

import Base.show, Base.print, Base.println

function show(io::IO, stats::AbstractExecutionStats)
  show(io, "Execution stats: $(getStatus(stats))")
end

# TODO: Expose NLPModels dsp in nlp_types.jl function print
function disp_vector(io::IO, x::AbstractArray)
  if length(x) == 0
    print(io, "∅")
  elseif length(x) <= 5
    Base.show_delim_array(io, x, "[", " ", "]", false)
  else
    Base.show_delim_array(io, x[1:4], "[", " ", "", false)
    print(io, " ⋯ $(x[end])]")
  end
end

function print(io::IO, stats::GenericExecutionStats; showvec::Function = disp_vector)
  # TODO: Show evaluations
  println(io, "Generic Execution stats")
  println(io, "  status: " * getStatus(stats))
  println(io, "  objective value: ", stats.objective)
  println(io, "  primal feasibility: ", stats.primal_feas)
  println(io, "  dual feasibility: ", stats.dual_feas)
  print(io, "  solution: ")
  showvec(io, stats.solution)
  println(io, "")
  length(stats.multipliers) > 0 &&
    (print(io, "  multipliers: "); showvec(io, stats.multipliers); println(io, ""))
  length(stats.multipliers_L) > 0 &&
    (print(io, "  multipliers_L: "); showvec(io, stats.multipliers_L); println(io, ""))
  length(stats.multipliers_U) > 0 &&
    (print(io, "  multipliers_U: "); showvec(io, stats.multipliers_U); println(io, ""))
  println(io, "  iterations: ", stats.iter)
  println(io, "  elapsed time: ", stats.elapsed_time)
  if length(stats.solver_specific) > 0
    println(io, "  solver specific:")
    for (k, v) in stats.solver_specific
      @printf(io, "    %s: ", k)
      if v isa Vector
        showvec(io, v)
      else
        show(io, v)
      end
      println(io, "")
    end
  end
end
print(stats::GenericExecutionStats; showvec::Function = disp_vector) =
  print(Base.stdout, stats, showvec = showvec)
println(io::IO, stats::GenericExecutionStats; showvec::Function = disp_vector) =
  print(io, stats, showvec = showvec)
println(stats::GenericExecutionStats; showvec::Function = disp_vector) =
  print(Base.stdout, stats, showvec = showvec)

const headsym = Dict(
  :status => "  Status",
  :iter => "   Iter",
  :neval_obj => "   #obj",
  :neval_grad => "  #grad",
  :neval_cons => "  #cons",
  :neval_jcon => "  #jcon",
  :neval_jgrad => " #jgrad",
  :neval_jac => "   #jac",
  :neval_jprod => " #jprod",
  :neval_jtprod => "#jtprod",
  :neval_hess => "  #hess",
  :neval_hprod => " #hprod",
  :neval_jhprod => "#jhprod",
  :objective => "              f",
  :dual_feas => "           ‖∇f‖",
  :elapsed_time => "  Elaspsed time",
)

function statsgetfield(stats::AbstractExecutionStats, name::Symbol)
  t = Int
  if name == :status
    v = getStatus(stats)
    t = String
  elseif name == :step_status
    v = getStepStatus(stats)
    t = String
  elseif name in fieldnames(typeof(stats))
    v = getfield(stats, name)
    t = fieldtype(typeof(stats), name)
  else
    error("Unknown field $name")
  end
  if t <: Int
    @sprintf("%7d", v)
  elseif t <: Real
    @sprintf("%15.8e", v)
  else
    @sprintf("%8s", v)
  end
end

function statshead(line::Array{Symbol})
  return join([headsym[x] for x in line], "  ")
end

function statsline(stats::AbstractExecutionStats, line::Array{Symbol})
  return join([statsgetfield(stats, x) for x in line], "  ")
end

function getStatus(stats::AbstractExecutionStats)
  return STATUSES[stats.status]
end

function getStepStatus(stats::AbstractExecutionStats)
  return STEP_STATUSES[stats.step_status]
end

"""
    get_status(problem, kwargs...)

Return the output of the solver based on the information in the keyword arguments.
Use `show_statuses()` for the full list.

The keyword arguments may contain:
- `elapsed_time::Float64 = 0.0`: current elapsed time (default: `0.0`);
- `iter::Integer = 0`: current number of iterations (default: `0`);
- `optimal::Bool = false`: `true` if the problem reached an optimal solution (default: `false`);
- `acceptable::Bool = false`: `true` if the problem reached a solution that is acceptable within tolerances (default: `false`);
- `small_residual::Bool = false`: `true` if the nonlinear least squares problem reached a solution with small residual (default: `false`);
- `infeasible::Bool = false`: `true` if the problem is infeasible (default: `false`);
- `prox_unbounded::Bool = false`: `true` if the regularizer is not prox bounded (default: `false`);
- `parameter_too_large::Bool = false`: `true` if the parameters are loo large (default: `false`);
- `unbounded::Bool = false`: `true` if the problem is unbounded (default: `false`);
- `neg_pred::Bool = false`: `true` if the predicted reduction is negative (default: `false`);
- `not_desc::Bool = false`: `true` if the direction is not a descent direction (default: `false`);
- `small_step::Bool = false`: `true` if the step is too small (default: `false`);
- `stalled::Bool = false`: `true` if the algorithm is stalling (default: `false`);
- `max_eval::Integer`: limit on the number of evaluations defined by `eval_fun` (default: `typemax(Int)`);
- `max_time::Float64 = Inf`: limit on the time (default: `Inf`);
- `max_iter::Integer`: limit on the number of iterations (default: `typemax(Int)`).

The `problem` is used to check number of evaluations with SolverCore.eval_fun(problem).
"""
function get_status(
  nlp;
  elapsed_time::Float64 = 0.0,
  iter::Integer = 0,
  optimal::Bool = false,
  acceptable::Bool = false,
  small_residual::Bool = false,
  infeasible::Bool = false,
  prox_unbounded::Bool = false,
  parameter_too_large::Bool = false,
  unbounded::Bool = false,
  neg_pred::Bool = false,
  not_desc::Bool = false,
  small_step::Bool = false,
  stalled::Bool = false,
  exception::Bool = false,
  max_eval::Integer = typemax(Int),
  max_time::Float64 = Inf,
  max_iter::Integer = typemax(Int),
)
  if optimal
    :first_order
  elseif acceptable
    :acceptable
  elseif small_residual
    :small_residual
  elseif infeasible
    :infeasible
  elseif unbounded
    :unbounded
  elseif neg_pred
    :neg_pred
  elseif not_desc
    :not_desc
  elseif small_step
    :small_step
  elseif stalled
    :stalled
  elseif iter > max_iter ≥ 0
    :max_iter
  elseif eval_fun(nlp) > max_eval ≥ 0
    :max_eval
  elseif elapsed_time > max_time
    :max_time
  elseif parameter_too_large
    :stalled
  elseif prox_unbounded
    :prox_unbounded
  elseif exception
    :exception
  else
    :unknown
  end
end
eval_fun(::Any) = typemax(Int)

@testset "test restart" begin
  nlp = HS10()
  solver = DummySolver(nlp)
  stats = GenericExecutionStats(nlp)
  solve!(solver, nlp, stats, verbose = false)
  @test stats.status == :first_order
  # Try with a new intial guess
  nlp.meta.x0 .= 0.2
  SolverCore.reset!(solver, nlp)
  solve!(solver, nlp, stats, verbose = false)
  @test stats.status == :first_order
  # Try with a new problem of the same size
  nlp = HS10()
  SolverCore.reset!(solver, nlp)
  solve!(solver, nlp, stats, verbose = false)
  @test stats.status == :first_order
end

using SolverCore
using Test
# Auxiliary packages
using NLPModels, NLPModelsTest
# stdlib
using LinearAlgebra, Logging

include("dummy-solver.jl")

#=
Don't add your tests to runtests.jl. Instead, create files named

    test-title-for-my-test.jl

The file will be automatically included inside a `@testset` with title "Title For My Test".
=#
for (root, dirs, files) in walkdir(@__DIR__)
  for file in files
    if isnothing(match(r"^test-.*\.jl$", file))
      continue
    end
    title = titlecase(replace(splitext(file[6:end])[1], "-" => " "))
    @testset "$title" begin
      include(file)
    end
  end
end

# non-allocating reshape
# see https://github.com/JuliaLang/julia/issues/36313
reshape_array(a, dims) = invoke(Base._reshape, Tuple{AbstractArray, typeof(dims)}, a, dims)

mutable struct DummySolver{S} <: AbstractOptimizationSolver
  x::S     # primal approximation
  gx::S    # gradient of objective
  y::S     # multipliers estimates
  rhs::S   # right-hand size of Newton system
  jval::S  # flattened Jacobian
  hval::S  # flattened Hessian
  wval::S  # flattened augmented matrix
  Δxy::S   # search direction
end

function DummySolver(nlp::AbstractNLPModel{T, S}) where {T, S <: AbstractVector{T}}
  nvar, ncon = nlp.meta.nvar, nlp.meta.ncon
  x = similar(nlp.meta.x0)
  gx = similar(nlp.meta.x0)
  y = similar(nlp.meta.y0)
  rhs = similar(nlp.meta.x0, nvar + ncon)
  jval = similar(nlp.meta.x0, ncon * nvar)
  hval = similar(nlp.meta.x0, nvar * nvar)
  wval = similar(nlp.meta.x0, (nvar + ncon) * (nvar + ncon))
  Δxy = similar(nlp.meta.x0, nvar + ncon)
  DummySolver{S}(x, gx, y, rhs, jval, hval, wval, Δxy)
end

function dummy_solver(
  nlp::AbstractNLPModel{T, S},
  args...;
  kwargs...,
) where {T, S <: AbstractVector{T}}
  solver = DummySolver(nlp)
  stats = GenericExecutionStats(nlp)
  solve!(solver, nlp, stats, args...; kwargs...)
end

function SolverCore.solve!(
  solver::DummySolver{S},
  nlp::AbstractNLPModel{T, S},
  stats::GenericExecutionStats;
  callback = (args...) -> nothing,
  x0::S = nlp.meta.x0,
  atol::Real = sqrt(eps(T)),
  rtol::Real = sqrt(eps(T)),
  max_eval::Int = 1000,
  max_time::Float64 = 30.0,
  verbose::Bool = true,
) where {T, S <: AbstractVector{T}}
  start_time = time()
  elapsed_time = 0.0
  set_time!(stats, elapsed_time)

  nvar, ncon = nlp.meta.nvar, nlp.meta.ncon
  x = solver.x .= x0
  rhs = solver.rhs
  dual = view(rhs, 1:nvar)
  cx = view(rhs, (nvar + 1):(nvar + ncon))
  gx = solver.gx
  y = solver.y
  jval = solver.jval
  hval = solver.hval
  wval = solver.wval
  Δxy = solver.Δxy
  nnzh = Int(nvar * (nvar + 1) / 2)
  nnzh == nlp.meta.nnzh || error("solver assumes Hessian is dense")
  nvar * ncon == nlp.meta.nnzj || error("solver assumes Jacobian is dense")

  grad!(nlp, x, gx)
  dual .= gx

  # assume the model returns a dense Jacobian in column-major order
  if ncon > 0
    cons!(nlp, x, cx)
    jac_coord!(nlp, x, jval)
    Jx = reshape_array(jval, (ncon, nvar))
    Jqr = qr(Jx')

    # compute least-squares multipliers
    # by solving Jx' y = -gx
    gx .*= -1
    ldiv!(y, Jqr, gx)

    # update dual <- dual + Jx' * y
    mul!(dual, Jx', y, one(T), one(T))
  end

  iter = 0
  set_iter!(stats, iter)
  ϵd = atol + rtol * norm(dual)
  ϵp = atol

  fx = obj(nlp, x)
  set_objective!(stats, fx)
  verbose && @info log_header([:iter, :f, :c, :dual, :t, :x], [Int, T, T, T, Float64, Char])
  verbose && @info log_row(Any[iter, fx, norm(cx), norm(dual), elapsed_time, 'c'])
  solved = norm(dual) < ϵd && norm(cx) < ϵp

  set_status!(
    stats,
    get_status(
      nlp,
      elapsed_time = elapsed_time,
      iter = iter,
      optimal = solved,
      max_eval = max_eval,
      max_time = max_time,
    ),
  )

  while stats.status == :unknown
    # assume the model returns a dense Hessian in column-major order
    # NB: hess_coord!() only returns values in the lower triangle
    hess_coord!(nlp, x, y, view(hval, 1:nnzh))

    # rearrange nonzeros so they correspond to a dense nvar x nvar matrix
    j = nvar * nvar
    i = nnzh
    k = 1
    while i > nvar
      for _ = 1:k
        hval[j] = hval[i]
        hval[i] = 0
        j -= 1
        i -= 1
      end
      j -= nvar - k
      k += 1
    end

    # fill in augmented matrix
    # W = [H J']
    #     [J 0 ]
    wval .= 0
    Wxy = reshape_array(wval, (nvar + ncon, nvar + ncon))
    Hxy = reshape_array(hval, (nvar, nvar))
    Wxy[1:nvar, 1:nvar] .= Hxy
    for i = 1:nvar
      Wxy[i, i] += sqrt(eps(T))
    end
    if ncon > 0
      Wxy[(nvar + 1):(nvar + ncon), 1:nvar] .= Jx
    end
    LBL = factorize(Symmetric(Wxy, :L))

    ldiv!(Δxy, LBL, rhs)
    Δxy .*= -1
    @views Δx = Δxy[1:nvar]
    @views Δy = Δxy[(nvar + 1):(nvar + ncon)]
    x .+= Δx
    y .+= Δy

    grad!(nlp, x, gx)
    dual .= gx
    if ncon > 0
      cons!(nlp, x, cx)
      jac_coord!(nlp, x, jval)
      Jx = reshape_array(jval, (ncon, nvar))
      Jqr = qr(Jx')
      gx .*= -1
      ldiv!(y, Jqr, gx)
      mul!(dual, Jx', y, one(T), one(T))
    end
    elapsed_time = time() - start_time
    set_time!(stats, elapsed_time)
    presid = norm(cx)
    dresid = norm(dual)
    set_residuals!(stats, presid, dresid)
    solved = dresid < ϵd && presid < ϵp

    iter += 1
    fx = obj(nlp, x)
    set_iter!(stats, iter)
    set_objective!(stats, fx)

    set_status!(
      stats,
      get_status(
        nlp,
        elapsed_time = elapsed_time,
        iter = iter,
        optimal = solved,
        max_eval = max_eval,
        max_time = max_time,
      ),
    )

    callback(nlp, solver, stats)

    verbose && @info log_row(Any[iter, fx, norm(cx), norm(dual), elapsed_time, 'd'])
  end

  set_residuals!(stats, norm(cx), norm(dual))
  z = has_bounds(nlp) ? zeros(T, nvar) : zeros(T, 0)
  set_multipliers!(stats, y, z, z)
  set_solution!(stats, x)
  return stats
end

@testset "Test allocations of solver specific" begin
  nlp = BROWNDEN()
  stats = GenericExecutionStats(nlp) # stats = GenericExecutionStats(nlp, solver_specific = Dict{Symbol, Bool}())
  function fake_solver(stats)
    set_solver_specific!(stats, :test, true)
    return stats
  end
  @allocated fake_solver(stats)
  a = @allocated fake_solver(stats)
  @test a == 0
end

@testset "test callback" begin
  nlp = HS10()
  callback(nlp, solver, stats) = begin
    if stats.iter ≥ 3
      set_status!(stats, :user)
    end
  end
  stats = dummy_solver(nlp, max_eval = 20, callback = callback)
  @test stats.iter == 3
end

using SolverCore
using Documenter

DocMeta.setdocmeta!(SolverCore, :DocTestSetup, :(using SolverCore); recursive = true)

const page_rename = Dict("developer.md" => "Developer docs") # Without the numbers
const numbered_pages = [
  file for
  file in readdir(joinpath(@__DIR__, "src")) if file != "index.md" && splitext(file)[2] == ".md"
]

makedocs(;
  modules = [SolverCore],
  authors = "Tangi Migot <tangi.migot@gmail.com>, Abel Soares Siqueira <abel.s.siqueira@gmail.com>, Dominique Orban <dominique.orban@gerad.ca>",
  repo = "https://github.com/JuliaSmoothOptimizers/SolverCore.jl/blob/{commit}{path}#{line}",
  sitename = "SolverCore.jl",
  format = Documenter.HTML(; canonical = "https://JuliaSmoothOptimizers.github.io/SolverCore.jl"),
  pages = ["index.md"; numbered_pages],
)

deploydocs(; repo = "github.com/JuliaSmoothOptimizers/SolverCore.jl")

function test_stats()
  show_statuses()
  nlp = HS10()
  stats = GenericExecutionStats(nlp)
  set_status!(stats, :first_order)
  set_objective!(stats, 1.0)
  set_residuals!(stats, 0.0, 1e-12)
  set_solution!(stats, ones(2))
  set_iter!(stats, 10)
  set_solver_specific!(stats, :matvec, 10)
  set_solver_specific!(stats, :dot, 25)
  set_solver_specific!(stats, :empty_vec, [])
  broadcast_solver_specific!(stats, :empty_vec, [])
  set_solver_specific!(stats, :axpy, 20)
  set_solver_specific!(stats, :ray, -1 ./ (1:100))

  show(stats)
  print(stats)
  println(stats)
  open("teststats.out", "w") do f
    println(f, stats)
  end

  println(stats, showvec = (io, x) -> print(io, x))
  open("teststats.out", "a") do f
    println(f, stats, showvec = (io, x) -> print(io, x))
  end

  line = [:status, :objective, :iter]
  for field in line
    value = statsgetfield(stats, field)
    println("$field -> $value")
  end
  println(statshead(line))
  println(statsline(stats, line))

  @testset "Testing inference" begin
    for T in (Float16, Float32, Float64, BigFloat)
      nlp = BROWNDEN(T)

      stats = GenericExecutionStats(nlp)
      set_status!(stats, :first_order)
      @test stats.status == :first_order
      @test stats.status_reliable
      @test typeof(stats.objective) == T
      @test typeof(stats.dual_feas) == T
      @test typeof(stats.primal_feas) == T

      nlp = HS14(T)

      stats = GenericExecutionStats(nlp)
      set_status!(stats, :first_order)
      @test stats.status == :first_order
      @test stats.status_reliable
      @test typeof(stats.objective) == T
      @test typeof(stats.dual_feas) == T
      @test typeof(stats.primal_feas) == T

      S = Vector{T}
      stats = GenericExecutionStats{T, S, S, Any}()
      set_status!(stats, :first_order)
      @test stats.status == :first_order
      @test stats.status_reliable
      @test typeof(stats.objective) == T
      @test typeof(stats.dual_feas) == T
      @test typeof(stats.primal_feas) == T
    end
  end

  @testset "Test throws" begin
    stats = GenericExecutionStats(nlp)
    @test_throws Exception set_status!(stats, :bad)
    @test_throws Exception GenericExecutionStats(:unkwown, nlp, bad = true)

    stats = GenericExecutionStats{Float64, Vector{Float64}, Vector{Float64}, Any}()
    @test_throws Exception set_status!(stats, :bad)
    @test_throws Exception set_step_status!(stats, :medium_well)
  end

  @testset "Testing Dummy Solver with multi-precision" begin
    for T in (Float16, Float32, Float64, BigFloat)
      nlp = HS10(T)
      solver = DummySolver(nlp)

      stats = with_logger(NullLogger()) do
        solve!(solver, nlp)
      end
      @test typeof(stats.objective) == T
      @test typeof(stats.dual_feas) == T
      @test typeof(stats.primal_feas) == T
      @test eltype(stats.solution) == T
      @test eltype(stats.multipliers) == T
      @test eltype(stats.multipliers_L) == T
      @test eltype(stats.multipliers_U) == T

      stats = GenericExecutionStats{T, Vector{T}, Vector{T}, Any}()
      SolverCore.reset!(stats, nlp)
      with_logger(NullLogger()) do
        solve!(solver, nlp, stats)
      end
      @test typeof(stats.objective) == T
      @test typeof(stats.dual_feas) == T
      @test typeof(stats.primal_feas) == T
      @test eltype(stats.solution) == T
      @test eltype(stats.multipliers) == T
      @test eltype(stats.multipliers_L) == T
      @test eltype(stats.multipliers_U) == T
    end
  end

  @testset "Test stats setters" begin
    T = Float64
    nlp = HS14(T)
    stats = GenericExecutionStats(nlp)
    fields = (
      "status",
      "solution",
      "objective",
      "primal_residual",
      "dual_residual",
      "multipliers",
      "bounds_multipliers",
      "iter",
      "step_status",
      "time",
      "solver_specific",
    )
    for f ∈ fields
      val = getfield(stats, Symbol("$(f)_reliable"))
      @test val == false
    end
    n = 2
    x = ones(T, n) / n
    set_status!(stats, :first_order)
    @test stats.status_reliable
    set_solution!(stats, x)
    @test stats.solution_reliable
    set_objective!(stats, obj(nlp, x))
    @test stats.objective_reliable
    set_residuals!(stats, 1.0e-3, 1.0e-4)
    @test stats.primal_residual_reliable
    @test stats.dual_residual_reliable
    set_multipliers!(stats, [2 / n], T[], T[])
    @test stats.multipliers_reliable
    @test stats.bounds_multipliers_reliable
    set_iter!(stats, 2)
    @test stats.iter_reliable
    set_step_status!(stats, :accepted)
    @test stats.step_status_reliable
    set_time!(stats, 0.1)
    @test stats.time_reliable
    set_solver_specific!(stats, :bla, "boo!")
    @test stats.solver_specific_reliable
    SolverCore.reset!(stats)
    for f ∈ fields
      val = getfield(stats, Symbol("$(f)_reliable"))
      @test val == false
    end
  end
end

test_stats()

@testset "Test get_status" begin
  nlp = BROWNDEN()
  @test get_status(nlp, optimal = true) == :first_order
  @test get_status(nlp, acceptable = true) == :acceptable
  @test get_status(nlp, small_residual = true) == :small_residual
  @test get_status(nlp, infeasible = true) == :infeasible
  @test get_status(nlp, unbounded = true) == :unbounded
  @test get_status(nlp, neg_pred = true) == :neg_pred
  @test get_status(nlp, not_desc = true) == :not_desc
  @test get_status(nlp, small_step = true) == :small_step
  @test get_status(nlp, stalled = true) == :stalled
  @test get_status(nlp, iter = 8, max_iter = 5) == :max_iter
  @test get_status(nlp, prox_unbounded = true) == :prox_unbounded
  for i = 1:2
    increment!(nlp, :neval_obj)
  end
  @test get_status(nlp, max_eval = 1) == :max_eval
  @test get_status(nlp, elapsed_time = 60.0, max_time = 1.0) == :max_time
  @test get_status(nlp, parameter_too_large = true) == :stalled
  @test get_status(nlp, exception = true) == :exception
  @test get_status(nlp) == :unknown
end

@testset "Test get_status for NLS" begin
  nlp = BNDROSENBROCK()
  @test get_status(nlp, optimal = true) == :first_order
  @test get_status(nlp, small_residual = true) == :small_residual
  @test get_status(nlp, infeasible = true) == :infeasible
  @test get_status(nlp, unbounded = true) == :unbounded
  @test get_status(nlp, stalled = true) == :stalled
  @test get_status(nlp, iter = 8, max_iter = 5) == :max_iter
  @test get_status(nlp, prox_unbounded = true) == :prox_unbounded
  for i = 1:2
    increment!(nlp, :neval_residual)
  end
  @test get_status(nlp, max_eval = 1) == :max_eval
  @test get_status(nlp, elapsed_time = 60.0, max_time = 1.0) == :max_time
  @test get_status(nlp, parameter_too_large = true) == :stalled
  @test get_status(nlp, exception = true) == :exception
  @test get_status(nlp) == :unknown
end

module SolverCoreNLPModelsExt

using SolverCore
using NLPModels:
  AbstractNLPModel,
  AbstractNLSModel,
  has_bounds,
  neval_cons,
  neval_obj,
  neval_residual,
  unconstrained

"""
    reset!(stats::GenericExecutionStats, nlp::AbstractNLPModel)

Reset the internal flags of `stats` to `false` to Indicate
that the contents should not be trusted.
If an `AbstractNLPModel` is also provided,
the pre-allocated vectors are adjusted to the problem size.
"""
function SolverCore.reset!(
  stats::GenericExecutionStats{T, S},
  nlp::AbstractNLPModel{T, S},
) where {T, S}
  stats.solution = similar(nlp.meta.x0)
  stats.multipliers = similar(nlp.meta.y0)
  stats.multipliers_L = similar(nlp.meta.y0, has_bounds(nlp) ? nlp.meta.nvar : 0)
  stats.multipliers_U = similar(nlp.meta.y0, has_bounds(nlp) ? nlp.meta.nvar : 0)
  SolverCore.reset!(stats)
  stats
end

"""
    solve!(solver, model; kwargs...)
    solve!(solver, model, stats; kwargs...)

Apply `solver` to `model`.

# Arguments

- `solver::AbstractOptimizationSolver`: solver structure to hold all storage necessary for a solve
- `model::AbstractNLPModel`: the model solved, see `NLPModels.jl`
- `stats::GenericExecutionStats`: stats structure to hold solution information.

The first invocation allocates and returns a new `GenericExecutionStats`.
The second one fills out a preallocated stats structure and allows for efficient re-solves.

The `kwargs` are passed to the solver.

# Return Value

- `stats::GenericExecutionStats`: stats structure holding solution information.
"""
function SolverCore.solve!(
  solver::AOS,
  model::AbstractNLPModel{T, S};
  kwargs...,
) where {AOS <: AbstractOptimizationSolver, T, S}
  stats = GenericExecutionStats(model)
  solve!(solver, model, stats; kwargs...)
end

function SolverCore.solve!(
  ::AbstractOptimizationSolver,
  ::AbstractNLPModel,
  ::GenericExecutionStats;
  kwargs...,
) end

function SolverCore.GenericExecutionStats(
  nlp::AbstractNLPModel{T, S};
  status::Symbol = :unknown,
  solution::S = similar(nlp.meta.x0),
  objective::T = T(Inf),
  dual_feas::T = T(Inf),
  primal_feas::T = unconstrained(nlp) ? zero(T) : T(Inf),
  multipliers::S = similar(nlp.meta.y0),
  multipliers_L::V = similar(nlp.meta.y0, has_bounds(nlp) ? nlp.meta.nvar : 0),
  multipliers_U::V = similar(nlp.meta.y0, has_bounds(nlp) ? nlp.meta.nvar : 0),
  iter::Int = -1,
  step_status::Symbol = :unknown,
  elapsed_time::Real = Inf,
  solver_specific::Dict{Symbol, Tsp} = Dict{Symbol, Any}(),
) where {T, S, V, Tsp}
  SolverCore.check_status(status)
  return GenericExecutionStats{T, S, V, Tsp}(
    false,
    status,
    false,
    solution,
    false,
    objective,
    false,
    dual_feas,
    false,
    primal_feas,
    false,
    multipliers,
    false,
    multipliers_L,
    multipliers_U,
    false,
    iter,
    false,
    step_status,
    false,
    elapsed_time,
    false,
    solver_specific,
  )
end

SolverCore.eval_fun(nlp::AbstractNLPModel) = neval_obj(nlp) + neval_cons(nlp)
SolverCore.eval_fun(nls::AbstractNLSModel) = neval_residual(nls) + neval_cons(nls)

end # end of module

export log_header, log_row

const formats = Dict{DataType, String}(
  Signed => "%6d",
  AbstractFloat => "%8.1e",
  AbstractString => "%15s",
  Symbol => "%15s",
  Char => "%c",
  Missing => "%15s",
)

const default_headers = Dict{Symbol, String}(
  :name => "Name",
  :elapsed_time => "Time",
  :objective => "f(x)",
  :dual_feas => "Dual",
  :primal_feas => "Primal",
)

for (typ, fmt) in formats
  hdr_fmt_foo = Symbol("header_formatter_$typ")
  len = match(r"\%([0-9]*)", fmt)[1]
  fmt2 = "%$(len)s"

  @eval begin
    row_formatter(x::$typ) = @sprintf($fmt, x)
    row_formatter(::Type{<:$typ}) = @sprintf($fmt2, "-")

    $hdr_fmt_foo(x) = @sprintf($fmt2, x)
    header_formatter(x::Union{Symbol, String}, ::Type{<:$typ}) = $hdr_fmt_foo(x)
  end
end

"""
    log_header(colnames, coltypes)

Creates a header using the names in `colnames` formatted according to the types in `coltypes`.
Uses internal formatting specification given by `SolverCore.formats` and default header
translation given by `SolverCore.default_headers`.

Input:
- `colnames::Vector{Symbol}`: Column names.
- `coltypes::Vector{DataType}`: Column types.

Keyword arguments:
- `hdr_override::Dict{Symbol,String}`: Overrides the default headers.
- `colsep::Int`: Number of spaces between columns (Default: 2)

See also [`log_row`](@ref).
"""
function log_header(
  colnames::AbstractVector{Symbol},
  coltypes::AbstractVector{DataType};
  hdr_override::Dict{Symbol, String} = Dict{Symbol, String}(),
  colsep::Int = 2,
)
  out = ""
  for (name, typ) in zip(colnames, coltypes)
    x = if haskey(hdr_override, name)
      hdr_override[name]
    elseif haskey(default_headers, name)
      default_headers[name]
    else
      string(name)
    end
    out *= header_formatter(x, typ) * " "^colsep
  end
  return out
end

"""
    log_row(vals)

Creates a table row from the values on `vals` according to their types. Pass the names
and types of `vals` to [`log_header`](@ref) for a logging table. Uses internal formatting
specification given by `SolverCore.formats`.

To handle a missing value, add the type instead of the number:

    @info log_row(Any[1.0, 1])
    @info log_row(Any[Float64, Int])

Prints

    [ Info:  1.0e+00       1
    [ Info:        -       -

Keyword arguments:
- `colsep::Int`: Number of spaces between columns (Default: 2)
"""
function log_row(vals; colsep::Int = 2)
  string_cols = (row_formatter(val) for val in vals)
  return join(string_cols, " "^colsep)
end

function test_logging()
  nlp = HS10()

  @info "Testing logger"
  log_header([:col_float, :col_int, :col_symbol, :col_string], [Float64, Int, Symbol, String])
  log_row([1.0, 1, :one, "one"])
  log_row([Float64, Int, Symbol, String])

  with_logger(ConsoleLogger()) do
    @info "Testing dummy solver with logger"
    dummy_solver(nlp, max_eval = 20)
  end
end

test_logging()

# [Developer documentation](@id dev_docs)

!!! note "Contributing guidelines"
    If you haven't, please read the [Contributing guidelines](90-contributing.md) first.

If you want to make contributions to this package that involves code, then this guide is for you.

## First time clone

!!! tip "If you have writing rights"
    If you have writing rights, you don't have to fork. Instead, simply clone and skip ahead. Whenever **upstream** is mentioned, use **origin** instead.

If this is the first time you work with this repository, follow the instructions below to clone the repository.

1. Fork this repo
2. Clone your repo (this will create a `git remote` called `origin`)
3. Add this repo as a remote:

   ```bash
   git remote add upstream https://github.com/JuliaSmoothOptimizers/SolverCore.jl
   ```

This will ensure that you have two remotes in your git: `origin` and `upstream`.
You will create branches and push to `origin`, and you will fetch and update your local `main` branch from `upstream`.

## Linting and formatting

Install a plugin on your editor to use [EditorConfig](https://editorconfig.org).
This will ensure that your editor is configured with important formatting settings.

We use [https://pre-commit.com](https://pre-commit.com) to run the linters and formatters.
In particular, the Julia code is formatted using [JuliaFormatter.jl](https://github.com/domluna/JuliaFormatter.jl), so please install it globally first:

```julia-repl
julia> # Press ]
pkg> activate
pkg> add JuliaFormatter
```

To install `pre-commit`, we recommend using [pipx](https://pipx.pypa.io) as follows:

```bash
# Install pipx following the link
pipx install pre-commit
```

With `pre-commit` installed, activate it as a pre-commit hook:

```bash
pre-commit install
```

To run the linting and formatting manually, enter the command below:

```bash
pre-commit run -a
```

**Now, you can only commit if all the pre-commit tests pass**.

## Testing

As with most Julia packages, you can just open Julia in the repository folder, activate the environment, and run `test`:

```julia-repl
julia> # press ]
pkg> activate .
pkg> test
```

## Working on a new issue

We try to keep a linear history in this repo, so it is important to keep your branches up-to-date.

1. Fetch from the remote and fast-forward your local main

   ```bash
   git fetch upstream
   git switch main
   git merge --ff-only upstream/main
   ```

2. Branch from `main` to address the issue (see below for naming)

   ```bash
   git switch -c 42-add-answer-universe
   ```

3. Push the new local branch to your personal remote repository

   ```bash
   git push -u origin 42-add-answer-universe
   ```

4. Create a pull request to merge your remote branch into the org main.

### Branch naming

- If there is an associated issue, add the issue number.
- If there is no associated issue, **and the changes are small**, add a prefix such as "typo", "hotfix", "small-refactor", according to the type of update.
- If the changes are not small and there is no associated issue, then create the issue first, so we can properly discuss the changes.
- Use dash separated imperative wording related to the issue (e.g., `14-add-tests`, `15-fix-model`, `16-remove-obsolete-files`).

### Commit message

- Use imperative or present tense, for instance: *Add feature* or *Fix bug*.
- Have informative titles.
- When necessary, add a body with details.
- If there are breaking changes, add the information to the commit message.

### Before creating a pull request

!!! tip "Atomic git commits"
    Try to create "atomic git commits" (recommended reading: [The Utopic Git History](https://blog.esciencecenter.nl/the-utopic-git-history-d44b81c09593)).

- Make sure the tests pass.
- Make sure the pre-commit tests pass.
- Fetch any `main` updates from upstream and rebase your branch, if necessary:

  ```bash
  git fetch upstream
  git rebase upstream/main BRANCH_NAME
  ```

- Then you can open a pull request and work with the reviewer to address any issues.

## Building and viewing the documentation locally

Following the latest suggestions, we recommend using `LiveServer` to build the documentation.
Here is how you do it:

1. Run `julia --project=docs` to open Julia in the environment of the docs.
1. If this is the first time building the docs
   1. Press `]` to enter `pkg` mode
   1. Run `pkg> dev .` to use the development version of your package
   1. Press backspace to leave `pkg` mode
1. Run `julia> using LiveServer`
1. Run `julia> servedocs()`

## Making a new release

To create a new release, you can follow these simple steps:

- Create a branch `release-x.y.z`
- Update `version` in `Project.toml`
- Update the `CHANGELOG.md`:
  - Rename the section "Unreleased" to "[x.y.z] - yyyy-mm-dd" (i.e., version under brackets, dash, and date in ISO format)
  - Add a new section on top of it named "Unreleased"
  - Add a new link in the bottom for version "x.y.z"
  - Change the "[unreleased]" link to use the latest version - end of line, `vx.y.z ... HEAD`.
- Create a commit "Release vx.y.z", push, create a PR, wait for it to pass, merge the PR.
- Go back to main screen and click on the latest commit (link: <https://github.com/JuliaSmoothOptimizers/SolverCore.jl/commit/main>)
- At the bottom, write `@JuliaRegistrator register`

After that, you only need to wait and verify:

- Wait for the bot to comment (should take < 1m) with a link to a PR to the registry
- Follow the link and wait for a comment on the auto-merge
- The comment should said all is well and auto-merge should occur shortly
- After the merge happens, TagBot will trigger and create a new GitHub tag. Check on <https://github.com/JuliaSmoothOptimizers/SolverCore.jl/releases>
- After the release is create, a "docs" GitHub action will start for the tag.
- After it passes, a deploy action will run.
- After that runs, the [stable docs](https://JuliaSmoothOptimizers.github.io/SolverCore.jl/stable) should be updated. Check them and look for the version number.

# [Contributing guidelines](@id contributing)

First of all, thanks for the interest!

We welcome all kinds of contribution, including, but not limited to code, documentation, examples, configuration, issue creating, etc.

Be polite and respectful, and follow the code of conduct.

## Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/SolverCore.jl/issues).
Focused suggestions and requests can also be opened as issues.
Before opening a pull request, start an issue or a discussion on the topic, please.

## Working on an issue

If you found an issue that interests you, comment on that issue what your plans are.
If the solution to the issue is clear, you can immediately create a pull request (see below).
Otherwise, say what your proposed solution is and wait for a discussion around it.

!!! tip
    Feel free to ping us after a few days if there are no responses.

If your solution involves code (or something that requires running the package locally), check the [developer documentation](91-developer.md).
Otherwise, you can use the GitHub interface directly to create your pull request.

```@meta
CurrentModule = SolverCore
```

# SolverCore

Documentation for [SolverCore](https://github.com/JuliaSmoothOptimizers/SolverCore.jl).

Core package to build novel algorithms in Julia.

## Contributors

```@raw html
<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->
```

# JSO-compliant solvers

The following are JSO-compliance expectations and recommendations that are implemented in JuliaSmoothOptimizers.

## Mandatory

- Create a function `solver_name(nlp::AbstractNLPModel; kwargs...)` that returns a `GenericExecutionStats`.

## Recommended

- Create a solver object `SolverName <: SolverCore.AbstractOptimizationSolver`.
- Store all memory-allocating things inside this object. This includes vectors, matrices, and possibly other objects.
- One of these objects should be `solver.x`, that stores the current iterate.
- Implement a constructor `SolverName(nlp; kwargs...)`.
- Implement `SolverCore.solve!(solver, nlp::AbstractNLPModel, stats::GenericExecutionStats)` and change `solver_name` to create a `SolverName` object and call `solve!`.
- Make sure that `solve!` is not allocating.
- Accept the following keyword arguments (`T` is float type and `V` is the container type):
  - `x::V = nlp.meta.x0`: The starting point.
  - `atol::T = sqrt(eps(T))`: Absolute tolerance for the gradient. Use in conjunction with the relative tolerance below to check $\Vert \nabla f(x_k)\Vert \leq \epsilon_a + \epsilon_r\Vert \nabla f(x_0)\Vert$.
  - `rtol::T = sqrt(eps(T))`: Relative tolerance for the gradient. See `atol` above.
  - `max_eval::Int = -1`: Maximum number of objective function evaluation plus constraint function evaluations. Negative number means unlimited.
  - `max_iter::Int = typemax(Int)`: Maximum number of iterations.
  - `max_time::Float64 = 30.0`: Maximum elapsed time.
  - `verbose::Int = 0`: Verbosity level. `0` means nothing and `1` means something. There are no rules on the level of verbosity yet.
  - `callback = (nlp, solver, stats) -> nothing`: A callback function to be called at the end of an iteration, before exit status are defined.
- Use `set_status!` and `get_status` to update `stats` before starting the method loop, and at the end of every iteration.
- Call the `callback` after running `set_status!` in both places.
- Define `done = stats.status != :unknown` and loop with `while !done`.
- To check for logic errors and stop the method use `set_status!(stats, ...)`, `done = true`, and `continue`, where the second argument of `set_status!` is one of the statuses available in SolverCore.STATUSES. You can call `SolverCore.show_statuses()` to see them. If you need more specific statuses, create an issue.
- Use the `set_...!(stats, ...)` functions from `SolverCore` to update the `stats`. For instance, `set_objective!(stats, f)`, `set_time!(stats, time() - start_time)`, and `set_dual_residual!(stats, gnorm)`.
- Don't log when `verbose == 0`. When logging, use `@info log_header(...)` and `@info log_row(...)`.
- Write docstrings for `SolverName`. The format is still a bit loose.
